var path = window.electron.path;

const commandObj = {};
commandObj.file_list=[];
commandObj.folder_name="";

var nameDrop=document.getElementById("name-input");
var folder_names = [];
var folder_idx = 0;

function setFolderName(str){
	folder_idx = folder_names.length+1;
	folder_names.push(str);
	nameDrop.value = str;
}


function refresh() {
  document.getElementById("result").innerHTML = commandObj.file_list.join("<br>");
}


async function executeCommand() {
	var str = getBaseFolderName(nameDrop.value);
	
	setFolderName(str);
	commandObj.folder_name = str;
	if (commandObj.file_list.length > 0 && commandObj.folder_name != "") {
		//alert("process invoke");
		await window.electron.file_manage_process(commandObj);
		
		//alert("process executed");
	  commandObj.folder_name = "";
		commandObj.file_list.splice(0);
		
		document.getElementById("name-input").value = "";
		document.getElementById("result").innerHTML = "";		
	} 
}

function getBaseFolderName(str) {
	var result = str;
		result = result.replace(/$\..+/, '');	
	if (result.indexOf("/") > -1) {
		var ary = result.split("/");
		ary = ary.filter(item => item.match(/.+/));
		alert(ary.slice(-1)[0]);
		result = ary.slice(-1)[0];
	}
  	return result;
}

// 実行ボタン
document.getElementById("execute-button").onclick =  executeCommand;	



// クリアボタン
document.getElementById("clear-button").onclick = function() {
  commandObj.file_list.splice(0);
  refresh();
};


// ドラッグエリア
var dragFile= document.getElementById("drag-file");

dragFile.addEventListener('drop', function (e) {
      e.preventDefault();
      e.stopPropagation();

      for (let f of e.dataTransfer.files) {
        if (commandObj.file_list.indexOf(f.path) == -1) {
          commandObj.file_list.push(f.path);
        }
      }
      refresh();
});

dragFile.addEventListener('dragover', function (e) {
        e.preventDefault();
        e.stopPropagation();
});



// フォルダ名入力欄

const ENTER_KEY = 13;
const UP_KEY = 38;
const DOWN_KEY = 40;

nameDrop.onkeydown = function(e) {
	//console.log(e.keyCode);
	if(typeof e.keyCode === "undefined" || e.keyCode === ENTER_KEY) {
		//enter
    executeCommand();
	}
	if (e.keyCode === UP_KEY) {
		//up
		if (folder_idx > 0) {
			folder_idx -= 1;
			nameDrop.value = folder_names[folder_idx];
		}
	}
	if (e.keyCode === DOWN_KEY) {
		//down
		if (folder_idx < folder_names.length) {
			folder_idx += 1;
			var str = folder_names[folder_idx];
			nameDrop.value = str === undefined ? "" : str;
		}
	}
		
};



nameDrop.addEventListener('drop', function (e) {
		var folder_name = path.basename(e.dataTransfer.files[0].path);
		folder_name = folder_name.replace(/$\..+/, '');	
		
    e.preventDefault();
		e.stopPropagation();
		setFolderName(folder_name);
});

nameDrop.addEventListener('dragover', function (e) {
        e.preventDefault();
        e.stopPropagation();
});


